#include "fische.h"

// Draw a Line
void line(int x1, int x2, int y1, int y2, int col){
	
	int c,greaterX,smallerX,greaterY,smallerY,g1;
	
	if((abs(x2-x1)+x1)!=x2){smallerX=x2;greaterX=x1;g1=1;}
	else{smallerX=x1;greaterX=x2;g1=0;}
	if((abs(y2-y1)+y1)!=y2){smallerY=y2;greaterY=y1;g1++;}
	else{smallerY=y1;greaterY=y2;}
	
	if((greaterX-smallerX)>(greaterY-smallerY)){
		if(g1==1){
			for(c=0;c<=abs(x2-x1);c++){
				PutPixel(smallerX+c,greaterY-c*abs(y1-y2)/abs(x1-x2),255);}}
		else{
			for(c=0;c<=abs(x2-x1);c++){
				PutPixel(smallerX+c,smallerY+c*abs(y1-y2)/abs(x1-x2),255);}}}
	if((greaterY-smallerY)>(greaterX-smallerX)){
		if(g1==1){
			for(c=0;c<=abs(y2-y1);c++){
				PutPixel(smallerX+c*abs(x1-x2)/abs(y1-y2),greaterY-c,255);}}
		else{
			for(c=0;c<=abs(y2-y1);c++){
				PutPixel(smallerX+c*abs(x1-x2)/abs(y1-y2),smallerY+c,255);}}}
	if(((greaterY-smallerY)==(greaterX-smallerX))&&(abs(x1-x2)!=0)){
		if(g1==1){
			for(c=0;c<=abs(y2-y1);c++){
				PutPixel(smallerX+c,greaterY-c,255);}}
		else{
			for(c=0;c<=abs(y2-y1);c++){
				PutPixel(smallerX+c,smallerY+c,255);}}}}
			

// Set proper resolution and initialize video mode
void setscreen(int xres, int yres, int fs){

	SDL_Init(SDL_INIT_TIMER|SDL_INIT_VIDEO);
	if (fs==1){
		sdl_screen = SDL_SetVideoMode(xres, yres, 32, SDL_HWSURFACE|SDL_HWACCEL|SDL_FULLSCREEN);
	}else{
		sdl_screen = SDL_SetVideoMode(xres, yres, 32, SDL_HWSURFACE|SDL_HWACCEL);
	}
	SDL_ShowCursor(SDL_DISABLE);
	SDL_EnableKeyRepeat(0,0);
	}

// Do cleanup work and quit SDL
void cleanup(){
	
	SDL_ShowCursor(SDL_ENABLE);
	SDL_Quit();
	free(pixeldata);
	free(vectorfield);}

// Make a Palette using channel maximum settings	
void makepalette(int rfactor, int gfactor, int bfactor){
	
	int i;
	
	for(i=0;i<256;i++){
		Color[i]=((i*rfactor/10)<<16)+((i*gfactor/10)<<8)+(i*bfactor/10);
	}
	if (rfactor<=8){rfactor++;}
	if (gfactor<=8){gfactor++;}
	if (bfactor<=8){bfactor++;}
	if (rfactor<=9){rfactor++;}
	if (gfactor<=9){gfactor++;}
	if (bfactor<=9){bfactor++;}
	i=255;
	Color[i]=((i*rfactor/10)<<16)+((i*gfactor/10)<<8)+(i*bfactor/10);
	}

// Make a rainbow palette
void makepalette_rgb(){

	int r,g,b,i;
	
	for(i=0;i<256;i++){
		r=(abs(4*(i-64))-255)*(-1);
			if (r<0){r=0;}
		g=(abs(4*(i-128))-255)*(-1);
			if (g<0){g=0;}
		b=(abs(4*(i-192))-255)*(-1);
			if (b<0){b=0;}
		Color[i]=((r<<16) + (g<<8) + b);
	}
	Color[255]=((255<<16) + (255<<8) + 255);
}

// Lock the screen for drawing to it directly
void lock(){
	
	if ( SDL_MUSTLOCK(sdl_screen) ) {
        if ( SDL_LockSurface(sdl_screen) < 0 ) {
            return;}}}

// Unlock the screen and update it
void unlock(){
	
	if ( SDL_MUSTLOCK(sdl_screen) ) {
        SDL_UnlockSurface(sdl_screen);}
    SDL_UpdateRect(sdl_screen, 0, 0, 0, 0);}
	
// Assign a color to the specified Pixel
void PutPixel(int x, int y, int col){

	Uint8 *bp;
	bp=pixeldata+y*XResolution+x;
	*bp=col;
	}

// Update the screen
void update(){
	
	int i,j;
	int jx=0;
	int jp=0;
	Uint32 *bp;
	Uint8 *sp;
	*(pixeldata+YResolution/2*XResolution+XResolution/2)=0;
	for(j=0;j<YResolution;j++){
		for(i=0;i<XResolution;i++){
			sp=pixeldata+jx+i;
			bp = sdl_screen->pixels+jp+i*4;
			*bp = Color[*sp];		
		}
		jp=jp+4*XResolution;
		jx=jx+XResolution;	
	}
}
				
void curve(){
	
	int OcX,OcY,cX,cY;
	if((frames_displayed%100==0)||(frames_displayed==0)){
		bends1=rand()%3+1;
		bends2=rand()%3+1;
		amp1=2; //rand()%2+1;
		amp2=1; //rand()%1+1;
	}
	curve_angle=curve_angle+PI/50;
	cX=(int)(cos(curve_angle*bends1)*50*amp1)+XResolution/2;
	cY=(int)(sin(curve_angle*bends2)*50*amp2)+YResolution/2;
	OcX=(int)(cos(bends1*(curve_angle-PI/50))*50*amp1)+XResolution/2;
	OcY=(int)(sin(bends2*(curve_angle-PI/50))*50*amp2)+YResolution/2;
	line(cX,OcX,cY,OcY,255);
	line(cX+1,OcX+1,cY,OcY,255);
	line(cX-1,OcX-1,cY,OcY,255);

}	